package com.company.tokenlist.web;

import com.company.tokenlist.entity.NewEntity;
import com.company.tokenlist.entity.SummNewEntity;
import com.google.common.collect.Lists;
import com.haulmont.cuba.gui.components.Button;
import com.haulmont.cuba.gui.components.TokenList;
import com.haulmont.cuba.gui.data.CollectionDatasource;
import com.haulmont.cuba.gui.data.Datasource;
import com.haulmont.cuba.gui.data.impl.CustomCollectionDatasource;
import com.haulmont.cuba.gui.model.*;
import com.haulmont.cuba.gui.screen.*;

import javax.inject.Inject;
import java.util.List;
import java.util.UUID;

@UiController("tokenlist_NewScreen")
@UiDescriptor("new-screen.xml")
@LoadDataBeforeShow
public class NewScreen extends Screen {

    @Inject
    Button button;
    @Inject
    TokenList tokenList;



   // @Inject
   // private CollectionLoader<NewEntity> newEntitiesDl;

    @Inject
    private InstanceContainer<SummNewEntity> newEntitiesDc;

    @Inject
    private CollectionContainer<NewEntity> newEntitiesDc_1;

    @Inject
    private DataComponents dataComponents;

    private InstanceLoader<SummNewEntity> summNewEntityDl;


    // @Inject
   // CollectionDatasource newEntitiesDc_1;





    @Subscribe
    protected void onInit(InitEvent event) {
        DataContext dataContext = dataComponents.createDataContext();
        getScreenData().setDataContext(dataContext);

        newEntitiesDc=dataComponents.createInstanceContainer(SummNewEntity.class);





        summNewEntityDl=dataComponents.createInstanceLoader();
        summNewEntityDl.setContainer(newEntitiesDc);

        summNewEntityDl.setLoadDelegate(fun->{
System.out.println("setLoadDelegate return return new SummNewEntity()!!!");
            SummNewEntity i0=new SummNewEntity();
            i0.getList().add(new NewEntity(String.valueOf("000"),String.valueOf("000") ));
            i0.getList().add(new NewEntity(String.valueOf("111"),String.valueOf("11") ));
            return i0;
        });


        summNewEntityDl.load();



        System.out.println("newEntitiesDc.getItem()="+newEntitiesDc.getItem());
    }


    @Subscribe
    protected void onBeforeShow(BeforeShowEvent event) {
       // newEntitiesDl.setParameter("customer", ""/*getEditedEntity()*/);
        //getScreenData().loadAll();
    }


    public void onButtonClick() {


        List<NewEntity> l= Lists.newArrayList();


        for(int i=0;i<10;i++){

            l.add(new NewEntity(String.valueOf(i),String.valueOf(i)) );
            //newEntitiesDc_1.setItems(l);//new NewEntity(String.valueOf(i),String.valueOf(i)));

        }
        newEntitiesDc_1.setItems(l);

       // SummNewEntity sne=new SummNewEntity();
       // newEntitiesDc.



    }


    public void onButton_1Click() {
        System.out.println("newEntitiesDc.getItem()="+newEntitiesDc.getItem());
        if(null!=newEntitiesDc.getItem())
        System.out.println("newEntitiesDc.getItem().getList().size()="+newEntitiesDc.getItem().getList().size());
    }
}