package com.company.tokenlist.entity;

import com.google.common.collect.Sets;
import com.haulmont.chile.core.annotations.MetaClass;
import com.haulmont.chile.core.annotations.MetaProperty;
import com.haulmont.cuba.core.entity.BaseUuidEntity;

import java.util.Set;

@MetaClass(name = "tokenlist_SummNewEntity")
public class SummNewEntity extends BaseUuidEntity {
    @MetaProperty
    protected String name;

    @MetaProperty
    protected Set<NewEntity> list;


    public SummNewEntity() {
        list= Sets.newLinkedHashSet();
    }

    public Set<NewEntity> getList() {
        return list;
    }

    public void setList(Set<NewEntity> list) {
        this.list = list;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}